local cv_trickwild = CV_RegisterVar({
    name = "as_wildtricks",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

-- CHAAAAARGE
addHook("MobjThinker", function(pmo)
    if not cv_trickwild.value then return end

    local player = pmo.player

    player.trickchaintimer = 52
    player.inchain = true
    player.trickgrade = 4
    player.chaincount = max(player.chaincount or 0, 5)

    if S_SoundPlaying(pmo, sfx_tric) then
        S_StopSoundByID(pmo, sfx_tric)
        S_StartSound(pmo, sfx_trice)
    end
end, MT_PLAYER)
