local k_respawn = k_respawn
local k_driftboost = k_driftboost
local k_sneakertimer = k_sneakertimer
local pks


local function K_JumpStore(p)	
	pks = p.kartstuff
		
	if pks[k_driftboost] > 0
		//print("DriftBoost:"..pks[k_driftboost])
		if (not P_IsObjectOnGround(p.mo))
		or pks[k_sneakertimer]
        or (pks[k_sneakertimer] and (p.tricksneakerbuffer or p.trickboost))
		and not pks[k_respawn]
			if p.JSlastMT then
				pks[k_driftboost] = p.JSlastMT
			end
		end
		
	end
	
	p.JSlastMT = pks[k_driftboost]
end


local function JS_DriftBoost(p)
	if p.JSlastdriftboost ~= nil then
		if p.JSlastdriftcharge > p.kartstuff[k_driftcharge] then
			local target = K_GetKartDriftSparkValue(p) -- Taken from source.
			local LDC = p.JSlastdriftcharge
			local fakecharge = 20 -- Taken from source.
			local fakename = "blue"
			
			if (p.JSlastbounced
			or p.speed <= 10*FRACUNIT
			or p.kartstuff[k_spinouttimer]
			or p.kartstuff[k_squishedtimer]
			or LDC < target
			or p.JSlastbuttons) then
				return
			elseif LDC >= target*4 then -- Rainbow and red MT values taken from source.
				fakecharge = 125
				fakename = "rainbow"
			elseif LDC >= target*2 then
				fakecharge = 50
				fakename = "red"
			end
			
			p.kartstuff[k_driftboost] = max(fakecharge, p.kartstuff[k_driftboost])
		end
	end
end

addHook("PlayerThink", function(p)
	if p.spectator then return end
	if leveltime < 3 then return end
	
	K_JumpStore(p)
	JS_DriftBoost(p)
	
	p.JSlastdriftboost = p.kartstuff[k_driftboost]
	p.JSlastdriftcharge = p.kartstuff[k_driftcharge]
	p.JSlastdrift = p.kartstuff[k_drift]
	p.JSlastbuttons = p.cmd.buttons & BT_DRIFT
	p.JSlastbounced = p.mo.eflags & MFE_JUSTBOUNCEDWALL
	p.JSlastMT = p.kartstuff[k_driftboost]
end)

local function JS_Init(p)
	p.JSlastdriftboost = 0
	p.JSlastdriftcharge = 0
	p.JSlastdrift = 0
	p.JSlastbuttons = 0
	p.JSlastbounced = 0
	p.JSlastMT = 0
end

addHook("PlayerSpawn", JS_Init)