for i = 1, 15 do
	freeslot("sfx_tmbi"..i)
end

for i = 1, 20 do
	freeslot("sfx_tmbc"..i)
end

local impactsfx = {
	sfx_tmbi1,
	sfx_tmbi2,
	sfx_tmbi3,
	sfx_tmbi4,
	sfx_tmbi5,
	sfx_tmbi6,
	sfx_tmbi7,
	sfx_tmbi8,
	sfx_tmbi9,
	sfx_tmbi10,
	sfx_tmbi11,
	sfx_tmbi12,
	sfx_tmbi13,
	sfx_tmbi14,
	sfx_tmbi15
}

local combosfx = {
	sfx_tmbc1,
	sfx_tmbc2,
	sfx_tmbc3,
	sfx_tmbc4,
	sfx_tmbc5,
	sfx_tmbc6,
	sfx_tmbc7,
	sfx_tmbc8,
	sfx_tmbc9,
	sfx_tmbc10,
	sfx_tmbc11,
	sfx_tmbc12,
	sfx_tmbc13,
	sfx_tmbc14,
	sfx_tmbc15,
	sfx_tmbc16,
	sfx_tmbc17,
	sfx_tmbc18,
	sfx_tmbc19,
	sfx_tmbc20
}

local function TMB_Impact(mo)
	local impact = impactsfx[P_RandomRange(1, #impactsfx)]
	S_StartSound(mo, impact)
end

local function TMB_Combo(mo)
	local combo = combosfx[P_RandomRange(1, #combosfx)]
	S_StartSound(mo, combo)
end

local function TMB_PlayerCrash(mo)
	return (mo.player 
			and ((mo.player.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and mo.player.hugequest.huge > 0))
			or mo.player.kartstuff[k_invincibilitytimer] > 0))
end

local function TMB_ImpactCheck(mo)
	return (mo.type == MT_JAWZ 
			or mo.type == MT_JAWZ_SHIELD
			or mo.type == MT_JAWZ_DUD
			or mo.type == MT_ORBINAUT
			or mo.type == MT_ORBINAUT_SHIELD
			or TMB_PlayerCrash(mo))
end

local function TMB_Spin(p, i, s)
	if not (p.mo and p.mo.valid) then return end
	if not (i and i.valid) then return end
	if not CV_FindVar("tumblememeenabled").value then return end

	if TMB_ImpactCheck(i) then
		TMB_Impact(p.mo)
		
		if P_RandomChance(FRACUNIT/3)
		or TMB_PlayerCrash(i)
		or (i.player and i.scale > p.mo.scale) then
			TMB_Combo(p.mo)
		end
	end
end
addHook("PlayerSpin", TMB_Spin)
addHook("PlayerSquish", TMB_Spin)