rawset(_G, "snow_enabled" , CV_RegisterVar({
	name = "snow_enabled",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))


local skytable = {
	8,  -- Casino Resort
	17, -- Blue Mountain
	55, -- Sub-Zero Peak
	75, -- Petroleum Refinery
	87, -- Crimson Core
	117 -- Toxic Palace
}

local function GG_SkyRoulette()
	return skytable[P_RandomRange(1, #skytable)]
end

local randsky
addHook("NetVars", function (net)
	randsky = net($)
end)

addHook("ThinkFrame", function()
	if not snow_enabled.value then return end
	if leveltime == 1
		randsky = GG_SkyRoulette()
		P_SetupLevelSky(randsky)
		P_SwitchWeather(2)
	end
end)
